2dd9580438342c42d8349b5d77c7de53813307ae
[exim.git] / src / scripts / drivers-Makefile
1 #! /bin/sh
2
3 # Copyright (c) The Exim Maintainers 1995 - 2024
4 # SPDX-License-Identifier: GPL-2.0-or-later
5
6 class=${CLASS:?}
7 classdef=${CLASSDEF:?}
8 drnames="${DRNAMES:?}"
9
10 # We turn the configure-built build-$foo/$class/Makefile.predynamic into Makefile.
11 # This is used for router and transport drivers, called from scripts/Configure-Makefile.
12
13 # We always re-exec ourselves at least once, because it's the cleanest and
14 # most portable way to turn on various features we expect of POSIX sh.
15 if [ -z "$EXIM_DRIVER_MAKEFILE_ADJUSTED" ]
16 then
17   SHELL=/bin/sh
18   EXIM_DRIVER_MAKEFILE_ADJUSTED=yes
19   export EXIM_DRIVER_MAKEFILE_ADJUSTED
20
21   # Solaris sh and tr are problematic until we get xpg4 variants
22   if [ -x /usr/xpg4/bin/sh ]
23   then
24     PATH="/usr/xpg4/bin:$PATH"
25     export PATH
26     SHELL=/usr/xpg4/bin/sh
27     export SHELL
28   fi
29
30   # IRIX uses /bin/ksh for sh but in a compatibility mode unless $_XPG == 1,
31   # where said compatibility mode disables $(...)
32   _XPG=1
33   export _XPG
34
35   # We need the _right_ tr, so must do that first; but if a shell which
36   # we're more confident is sane is available, let's try that.  Mostly,
37   # the problem is that "local" is not actually in "the" standard, it's
38   # just in every not-insane shell.  Though arguably, there are no shells
39   # with POSIX-ish syntax which qualify as "not insane".
40   for b in /bin/dash /bin/bash /usr/local/bin/bash
41   do
42     if [ -x "$b" ]
43     then
44       SHELL="$b"
45       break
46     fi
47   done
48   # if we get a report of a system with zsh but not bash, we can add that
49   # to the list, but be sure to enable sh_word_split in that case.
50
51   exec "$SHELL" "$0" "$@"
52 fi
53
54 input=$class/Makefile.predynamic
55 target=$class/Makefile.postdynamic
56 defs_source=Makefile-t
57 tag_marker='MAGIC-TAG-MODS-OBJ-RULES-GO-HERE'
58
59 tab='   '
60
61 # We rely on tr(1) for translating case below.  Some people export
62 # values of LC_CTYPE and LC_COLLATE which apparently break our assumptions.
63 # We're a script expecting certain output based on known inputs and not dealing
64 # with UTF8, so we should be safe doing this:
65 LC_ALL=C
66 export LC_ALL
67
68 if [ -f "$defs_source" ]
69 then
70   :
71   # we are happy
72 else
73   echo >&2 "$0: ERROR: MISSING FILE '${defs_source}'"
74   echo >&2 "$0: SHOULD HAVE BEEN CALLED FROM scripts/Configure-Makefile"
75   exit 1
76 fi
77
78 # nb: do not permit leading whitespace for this, as CFLAGS_DYNAMIC is exported
79 # to the lookups subdir via a line with leading whitespace which otherwise
80 # matches
81 if grep -q "^CFLAGS_DYNAMIC[ $tab?:]*=" "$defs_source"
82 then
83   # we have a definition, we're good to go
84   echo >&2 ">>> Creating $class/Makefile for building dynamic modules"
85   enable_dynamic=yes
86 else
87   echo >&2 ">>> Creating $class/Makefile without dynamic module support"
88   enable_dynamic=''
89   # We always do something now, since there should always be a lookup,
90   # and now we need to run in order to put the OBJ=$(OBJ)+ rules in.  So we
91   # continue on.
92 fi
93
94 # For the want_ checks, we need to let the user override values from the make
95 # command-line, not just check the Makefile.
96
97 want_dynamic() {
98   local dyn_name="$1"
99   local re="(${classdef}|EXPERIMENTAL)_${dyn_name}[ $tab]*=[ $tab]*2"
100   env | grep -E -q "^$re"
101   if [ $? -eq 0 ]; then return 0; fi
102   grep -E -q "^[ $tab]*$re" "$defs_source"
103 }
104
105 want_at_all() {
106   local want_name="$1"
107   local re="(${classdef}|EXPERIMENTAL)_${want_name}[ $tab]*=[ $tab]*."
108   env | grep -E -q "^$re"
109   if [ $? -eq 0 ]; then return 0; fi
110   grep -E -q "^[ $tab]*$re" "$defs_source"
111 }
112
113 # The values of these variables will be emitted into the Makefile.
114
115 MODS=""
116 OBJ=""
117
118 emit_module_rule() {
119   local name="$1"
120   local mod_name pkgconf
121   if [ "${name%:*}" = "$name" ]
122   then
123     # Square brackets are redundant but benign for POSIX compliant tr,
124     # however Solaris /usr/bin/tr requires them. Sometimes Solaris
125     # gets installed without a complete set of xpg4 tools, sigh.
126     mod_name=$(echo $name | tr [A-Z] [a-z])
127   else
128     mod_name="${name#*:}"
129     name="${name%:*}"
130   fi
131
132   if want_dynamic "$name"
133   then
134     if [ -z "$enable_dynamic" ]; then
135       echo >&2 "Missing CFLAGS_DYNAMIC prevents building dynamic $name"
136       exit 1
137     fi
138     MODS="${MODS} ${mod_name}.so"
139     grep "^${classdef}_${name}_PC" "$defs_source" 1>&2
140     pkgconf=$(grep "^${classdef}_${name}_PC" "$defs_source")
141     if [ $? -eq 0 ]; then
142       pkgconf=$(echo $pkgconf | sed 's/^.*= *//')
143       echo "${classdef}_${mod_name}_INCLUDE = $(pkg-config --cflags $pkgconf)"
144       echo "${classdef}_${mod_name}_LIBS = $(pkg-config --libs $pkgconf)"
145     else
146       grep "^${classdef}_${name}_" "$defs_source"
147       echo "${classdef}_${mod_name}_INCLUDE = \$(${classdef}_${name}_INCLUDE)"
148       echo "${classdef}_${mod_name}_LIBS = \$(${classdef}_${name}_LIBS)"
149     fi
150   elif want_at_all "$name"
151   then
152     OBJ="${OBJ} ${mod_name}.o"
153   fi
154 }
155
156 rm -f "$target"
157 exec 5>&1
158 exec > "$target"
159
160 sed -n "1,/$tag_marker/p" < "$input"
161
162 for name_mod in $drnames
163 do
164   emit_module_rule $name_mod
165 done
166
167 echo "MODS = $MODS"
168 echo "OBJ = $OBJ"
169
170 sed -n "/$tag_marker/,\$p" < "$input"
171
172 exec >&5
173
174 # Configure-Makefile will move $target into place
175
176 # vim: set ft=sh sw=2 :